# 1. Documenting architecture decisions

Date: 2020-04-05

## Status

Status: Accepted on 2020-04-05

## Context

We need to record the architectural decisions made on this project.

## Decision

We will use Architecture Decision Records, as [described by Michael Nygard](http://thinkrelevance.com/blog/2011/11/15/documenting-architecture-decisions).

## Consequences

* We wil spend our time writting ADRs
* Developers and project stakeholders can see the ADRs
* 1 ADR for 1 project wide decision
* Context behind past decisions visible for everyone

### References

* See [Michael Nygard's article](http://thinkrelevance.com/blog/2011/11/15/documenting-architecture-decisions) for more info about ADR.
* For ADR toolset, see [@npryce](https://github.com/npryce)'s [adr-tools](https://github.com/npryce/adr-tools).
* For a Visual Studio Code ADR toolset extention, see [@vincent-ledu](https://github.com/vincent-ledu)'s [adr-tools](https://marketplace.visualstudio.com/items?itemName=vincent-ledu.adr-tools)
* For ADR templates, see [@kopach](https://github.com/kopach)'s [ADR templates](https://github.com/kopach/adr-templates)
